'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Devtool = require('./devtool/Devtool');

var _EditorInputs = require('./modules/EditorInputs');

var _EditorInputs2 = _interopRequireDefault(_EditorInputs);

var _EditorBlock = require('./modules/EditorBlock');

var _EditorBlock2 = _interopRequireDefault(_EditorBlock);

var _EditorUtils = require('./modules/EditorUtils');

var _EditorUtils2 = _interopRequireDefault(_EditorUtils);

var _EditorFiles = require('./modules/EditorFiles');

var _EditorFiles2 = _interopRequireDefault(_EditorFiles);

var _EditorSave = require('./modules/EditorSave');

var _EditorSave2 = _interopRequireDefault(_EditorSave);

var _EditorManager = require('./modules/EditorManager');

var _EditorManager2 = _interopRequireDefault(_EditorManager);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Engine = function () {
  function Engine() {
    _classCallCheck(this, Engine);

    this._blocks = new _EditorBlock2.default();
    this._inputs = new _EditorInputs2.default();
    this._files = new _EditorFiles2.default();
    this._save = new _EditorSave2.default();
    this._manager = new _EditorManager2.default();
    this._dev = new _Devtool.Devtool();

    this._bindEvents();

    $(document).ready(function () {
      $('#navigation-list').DataTable({
        "pageLength": 50,
        "autoWidth": false
      });
    });
  }

  _createClass(Engine, [{
    key: '_bindEvents',
    value: function _bindEvents() {
      var _this = this;

      this._blocks.onNewBlock(function () {
        _this._files.rebind();
        _this._inputs.rebind();
      });

      this._inputs.onBlur(function () {
        _this._save.serializeForm();
      });

      this._blocks.onRemoveBlock(function () {
        _this._inputs.rebind();
        _this._save.serializeForm(); ///**************************************** HOOLA
      });
    }
  }]);

  return Engine;
}();

var engine = new Engine();