import path from 'path'

import {
  Util,
  FileParser,
  fileUtils,
  fileAttr,
  config,
  cli,
  log,
  Page
} from '../'

export default class User {

  constructor(session, query){
    if(typeof query.role !== 'undefined' && query.role !== null) session.role = query.role
    else if(!session.role) session.role = 'admin'

    this._role = session.role
    this._actions = this.setActions()
  }

  setActions(){
    var allowedActions = {}
    config.actions.forEach((action) => {
      var userActions = config["roles"][this._role]["actions"]
      if(userActions === '*' || userActions.indexOf(action) > -1) allowedActions[action] = 1
    })
    return allowedActions
  }

  get actions(){
    return this._actions
  }

  get role(){
    return this._role
  }

  set infos(role){
    this._role = role
  }

}
