import fse from 'fs-extra'
import clc from 'cli-color'
import extend from 'extend'

import hooksDefault from "../../hooks/hooks"

import {
  Util,
  FileParser,
  config,
  fileUtils,
  cli,
  log
} from '../'

let singleton = Symbol()
let singletonEnforcer = Symbol()

class Hooks {

  constructor(enforcer) {
  	if(enforcer != singletonEnforcer) throw "Cannot construct Json singleton"

    if(fileUtils.isFile(fileUtils.concatPath(config.root, config.hooks.url, 'hooks.js'))){
      var h = require(fileUtils.concatPath(config.root, config.hooks.url, 'hooks.js'))
      this.fn = extend(true, hooksDefault, h.default)
    }
    else{
      this.fn = hooksDefault
    }
  }

  static get instance() {
    if(!this[singleton]) {
      this[singleton] = new Hooks(singletonEnforcer)
    }
    return this[singleton]
  }
}

export default Hooks