import {Devtool} from './devtool/Devtool'

import EditorInputs from './modules/EditorInputs'
import EditorBlock from './modules/EditorBlock'
import EditorUtils from './modules/EditorUtils'
import EditorFiles from './modules/EditorFiles'
import EditorSave from './modules/EditorSave'
import EditorManager from './modules/EditorManager'

class Engine {

  constructor() {
    this._blocks = new EditorBlock()
    this._inputs = new EditorInputs()
    this._files = new EditorFiles()
    this._save = new EditorSave()
    this._manager = new EditorManager()
    this._dev = new Devtool()

    this._bindEvents()

    $(document).ready(function() {
      $('#navigation-list').DataTable({
        "pageLength": 50,
        "autoWidth": false
      })
    })
  }

  _bindEvents() {

    this._blocks.onNewBlock(() => {
      this._files.rebind()
      this._inputs.rebind()
    })

    this._inputs.onBlur(() => {
      this._save.serializeForm()
    })

    this._blocks.onRemoveBlock(() => {
    	this._inputs.rebind()
      this._save.serializeForm() ///**************************************** HOOLA
    })
  }
}

var engine = new Engine()